#include <setjmp.h>
#include <signal.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "func.inc"

typedef void (*PfnVoid)(void);

#define TEST(where) \
	printf("%8p is " #where " ... ", in_##where); fflush(stdout); \
	received_sigill = 0; \
	if (0 == setjmp(env)) { (*(PfnVoid)in_##where)(); } \
	printf(" sigill=%d\n", received_sigill);
#define MEMCPY_TEST(where) \
	memcpy(in_##where, in_code, sizeof(in_code)); \
	TEST(where)

static jmp_buf env;
static int received_sigill = 0;
static void on_sigill(int sig)
{
  signal(SIGILL, on_sigill);
  printf(" on_sigill=%d ", sig);
  received_sigill = 1;
  longjmp(env, 1);
}

static char in_data[sizeof(in_code)];

int main()
{
  char* in_heap = malloc(sizeof(in_code));
  char in_stack[sizeof(in_code)];

  signal(SIGILL, on_sigill);
  TEST(code);
  MEMCPY_TEST(data);
  MEMCPY_TEST(heap);
  MEMCPY_TEST(stack);
  return 0;
}
